--
-- Roll-Spezialization z.B fr ein Lfterrad 
-- luft nach dem verlassen des Fahrzeuges weiter, wenn der Motor luft!
--

roll = {};
 
function roll.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;
 
function roll:load(xmlFile)

self.rollNodes = {};

    local rollNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.roll#index"));
    if rollNode ~= nil then
        local speed = 0.003*3;
        table.insert(self.rollNodes, {node=rollNode, speed=speed});
    end;
    local i = 0;
    while true do
        local key = string.format("vehicle.rolls.roll(%d)", i);
        if not hasXMLProperty(xmlFile, key) then
            break;
        end;
        local rollNode = Utils.indexToObject(self.components, getXMLString(xmlFile, key.."#index"));
        local speed = Utils.getNoNil(getXMLFloat(xmlFile, key.."#speed"), 0.003);
        if rollNode ~= nil then
            table.insert(self.rollNodes, {node=rollNode, speed=speed});
        end;
        i = i + 1;
end;
end;
function roll:delete()
end;
 
function roll:mouseEvent(posX, posY, isDown, isUp, button)
end;
 
function roll:keyEvent(unicode, sym, modifier, isDown) 
end;
 
function roll:update(dt)       

	    if self.isMotorStarted then
          for _, rollNode in pairs(self.rollNodes) do
          rotate(rollNode.node, 0, 0, -dt*rollNode.speed);
          end;
		end;
	  end;
function roll:updateTick(dt)    
end;    

function roll:onEnter()
end;

function roll:draw() 
end;    

function roll:onLeave()
end;

function roll:updateTick(dt)     
end;